<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_PositionsResult_V7 StructType
 * @subpackage Structs
 */
class Get_PositionsResult_V7 extends ExecutionResult
{
    /**
     * The SynchronizedUntilDate
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var string
     */
    public $SynchronizedUntilDate;
    /**
     * The SynchronizedUntilId
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var int
     */
    public $SynchronizedUntilId;
    /**
     * The Positions
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfPositionItemResult_V7
     */
    public $Positions;
    /**
     * Constructor method for Get_PositionsResult_V7
     * @uses Get_PositionsResult_V7::setSynchronizedUntilDate()
     * @uses Get_PositionsResult_V7::setSynchronizedUntilId()
     * @uses Get_PositionsResult_V7::setPositions()
     * @param string $synchronizedUntilDate
     * @param int $synchronizedUntilId
     * @param \ArrayType\ArrayOfPositionItemResult_V7 $positions
     */
    public function __construct($synchronizedUntilDate = null, $synchronizedUntilId = null, \ArrayType\ArrayOfPositionItemResult_V7 $positions = null)
    {
        $this
            ->setSynchronizedUntilDate($synchronizedUntilDate)
            ->setSynchronizedUntilId($synchronizedUntilId)
            ->setPositions($positions);
    }
    /**
     * Get SynchronizedUntilDate value
     * @return string
     */
    public function getSynchronizedUntilDate()
    {
        return $this->SynchronizedUntilDate;
    }
    /**
     * Set SynchronizedUntilDate value
     * @param string $synchronizedUntilDate
     * @return \StructType\Get_PositionsResult_V7
     */
    public function setSynchronizedUntilDate($synchronizedUntilDate = null)
    {
        // validation for constraint: string
        if (!is_null($synchronizedUntilDate) && !is_string($synchronizedUntilDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($synchronizedUntilDate, true), gettype($synchronizedUntilDate)), __LINE__);
        }
        $this->SynchronizedUntilDate = $synchronizedUntilDate;
        return $this;
    }
    /**
     * Get SynchronizedUntilId value
     * @return int
     */
    public function getSynchronizedUntilId()
    {
        return $this->SynchronizedUntilId;
    }
    /**
     * Set SynchronizedUntilId value
     * @param int $synchronizedUntilId
     * @return \StructType\Get_PositionsResult_V7
     */
    public function setSynchronizedUntilId($synchronizedUntilId = null)
    {
        // validation for constraint: int
        if (!is_null($synchronizedUntilId) && !(is_int($synchronizedUntilId) || ctype_digit($synchronizedUntilId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($synchronizedUntilId, true), gettype($synchronizedUntilId)), __LINE__);
        }
        $this->SynchronizedUntilId = $synchronizedUntilId;
        return $this;
    }
    /**
     * Get Positions value
     * @return \ArrayType\ArrayOfPositionItemResult_V7|null
     */
    public function getPositions()
    {
        return $this->Positions;
    }
    /**
     * Set Positions value
     * @param \ArrayType\ArrayOfPositionItemResult_V7 $positions
     * @return \StructType\Get_PositionsResult_V7
     */
    public function setPositions(\ArrayType\ArrayOfPositionItemResult_V7 $positions = null)
    {
        $this->Positions = $positions;
        return $this;
    }
}
